diff --git a/include/time.h b/include/time.h
index eb5082b4d7..f23bfea737 100644
--- a/include/time.h
+++ b/include/time.h
@@ -191,11 +191,16 @@ libc_hidden_proto (__timerfd_gettime64);
 
 #if __TIMESIZE == 64
 # define __timer_settime64 __timer_settime
+# define __timerfd_settime64 __timerfd_settime
 #else
 extern int __timer_settime64 (timer_t timerid, int flags,
                               const struct __itimerspec64 *value,
                               struct __itimerspec64 *ovalue);
+extern int __timerfd_settime64 (int fd, int flags,
+                                const struct __itimerspec64 *value,
+                                struct __itimerspec64 *ovalue);
 libc_hidden_proto (__timer_settime64);
+libc_hidden_proto (__timerfd_settime64);
 #endif
 
 /* Compute the `struct tm' representation of T,
diff --git a/sysdeps/unix/sysv/linux/Makefile b/sysdeps/unix/sysv/linux/Makefile
index e599fcec23..70cf06bf36 100644
--- a/sysdeps/unix/sysv/linux/Makefile
+++ b/sysdeps/unix/sysv/linux/Makefile
@@ -19,7 +19,7 @@ sysdep_routines += adjtimex clone umount umount2 readahead \
 		   eventfd eventfd_read eventfd_write prlimit \
 		   personality epoll_wait tee vmsplice splice \
 		   open_by_handle_at mlock2 pkey_mprotect pkey_set pkey_get \
-		   timerfd_gettime
+		   timerfd_gettime timerfd_settime
 
 CFLAGS-gethostid.c = -fexceptions
 CFLAGS-tee.c = -fexceptions -fasynchronous-unwind-tables
diff --git a/sysdeps/unix/sysv/linux/syscalls.list b/sysdeps/unix/sysv/linux/syscalls.list
index 385007c662..16c673fc1a 100644
--- a/sysdeps/unix/sysv/linux/syscalls.list
+++ b/sysdeps/unix/sysv/linux/syscalls.list
@@ -94,7 +94,6 @@ fremovexattr	-	fremovexattr	i:is	fremovexattr
 mq_setattr	-	mq_getsetattr	i:ipp	mq_setattr
 
 timerfd_create	EXTRA	timerfd_create	i:ii	timerfd_create
-timerfd_settime	EXTRA	timerfd_settime	i:iipp	timerfd_settime
 
 fanotify_init	EXTRA	fanotify_init	i:ii	fanotify_init
 
diff --git a/sysdeps/unix/sysv/linux/timerfd_settime.c b/sysdeps/unix/sysv/linux/timerfd_settime.c
new file mode 100644
index 0000000000..bc7641ede0
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/timerfd_settime.c
@@ -0,0 +1,88 @@
+/* Copyright (C) 2003-2019 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+   Contributed by Ulrich Drepper <drepper@redhat.com>, 2003.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public License as
+   published by the Free Software Foundation; either version 2.1 of the
+   License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; see the file COPYING.LIB.  If
+   not, see <https://www.gnu.org/licenses/>.  */
+
+#include <errno.h>
+#include <stdlib.h>
+#include <time.h>
+#include <sysdep.h>
+#include <kernel-features.h>
+
+int
+__timerfd_settime64 (int fd, int flags, const struct __itimerspec64 *value,
+                     struct __itimerspec64 *ovalue)
+{
+  if (fd < 0)
+    return INLINE_SYSCALL_ERROR_RETURN_VALUE (EBADF);
+
+#ifdef __ASSUME_TIME64_SYSCALLS
+# ifndef __NR_timerfd_settime64
+#  define __NR_timerfd_settime64 __NR_timerfd_settime
+# endif
+  return INLINE_SYSCALL_CALL (timerfd_settime64, fd, flags, value, ovalue);
+#else
+# ifdef __NR_timerfd_settime64
+  int ret = INLINE_SYSCALL_CALL (timerfd_settime64, fd, flags, value, ovalue);
+  if (ret == 0 || errno != ENOSYS)
+    return ret;
+# endif
+  struct itimerspec its32, oits32;
+
+  if (! in_time_t_range ((value->it_value).tv_sec)
+      || ! in_time_t_range ((value->it_interval).tv_sec))
+    {
+      __set_errno (EOVERFLOW);
+      return -1;
+    }
+
+  its32.it_interval = valid_timespec64_to_timespec (value->it_interval);
+  its32.it_value = valid_timespec64_to_timespec (value->it_value);
+
+  int retval = INLINE_SYSCALL_CALL (timerfd_settime, fd, flags,
+                                    &its32, ovalue ? &oits32 : NULL);
+  if (retval == 0 && ovalue)
+    {
+      ovalue->it_interval = valid_timespec_to_timespec64 (oits32.it_interval);
+      ovalue->it_value = valid_timespec_to_timespec64 (oits32.it_value);
+    }
+
+  return retval;
+#endif
+}
+
+#if __TIMESIZE != 64
+int
+__timerfd_settime (int fd, int flags, const struct itimerspec *value,
+                   struct itimerspec *ovalue)
+{
+  struct __itimerspec64 its64, oits64;
+  int retval;
+
+  its64.it_interval = valid_timespec_to_timespec64 (value->it_interval);
+  its64.it_value = valid_timespec_to_timespec64 (value->it_value);
+
+  retval = __timerfd_settime64 (fd, flags, &its64, ovalue ? &oits64 : NULL);
+  if (retval == 0 && ovalue)
+    {
+      ovalue->it_interval = valid_timespec64_to_timespec (oits64.it_interval);
+      ovalue->it_value = valid_timespec64_to_timespec (oits64.it_value);
+    }
+
+  return retval;
+}
+#endif
+strong_alias (__timerfd_settime, timerfd_settime)